VERSION 5.00
Begin VB.Form ClientForm 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Client"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4080
   Icon            =   "ClientForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4080
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command7 
      Caption         =   "Makro: EndServer"
      Height          =   405
      Left            =   2340
      TabIndex        =   8
      Tag             =   "1"
      Top             =   2760
      Width           =   1725
   End
   Begin VB.CommandButton Command6 
      Caption         =   "Makro: ShowServer"
      Height          =   405
      Left            =   2340
      TabIndex        =   7
      Top             =   2310
      Width           =   1725
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Makro: HideServer"
      Height          =   405
      Left            =   2340
      TabIndex        =   6
      Top             =   1890
      Width           =   1725
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Makro: SetText"
      Height          =   405
      Left            =   2340
      TabIndex        =   5
      Top             =   1440
      Width           =   1725
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Makro: DelText"
      Height          =   405
      Left            =   2340
      TabIndex        =   4
      Top             =   990
      Width           =   1725
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Makro: Problemm"
      Height          =   405
      Left            =   2340
      TabIndex        =   3
      Top             =   540
      Width           =   1725
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Makro: ServerInfo"
      Height          =   405
      Left            =   2340
      TabIndex        =   2
      Top             =   90
      Width           =   1725
   End
   Begin VB.TextBox Text1 
      Height          =   2775
      Left            =   0
      LinkItem        =   "ServerText"
      LinkTimeout     =   100
      LinkTopic       =   "Server|Talk"
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   90
      Width           =   2295
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Zentriert
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "Label1"
      Height          =   285
      Left            =   0
      LinkItem        =   "ZeitLabel"
      LinkTimeout     =   100
      LinkTopic       =   "Server|Talk"
      TabIndex        =   1
      Top             =   2910
      Width           =   2295
   End
End
Attribute VB_Name = "ClientForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Source von Markus Zeichner
'
' DDE-Client:
' Der Client wird ber folgender Controls(Label/Text/Picture) an den Server
' gebunden:
' - ListItem (Name des Server-Steuerelementes von dem die Daten kommen
'   sollen,  muss 100% bereinstimmen !!!)
' - LinkTopic (hier steht der Servername (Programmname ohne Extension !!!)
'   und das  DDE-Thema getrent mit | . Also wenn der Serverprogramm
'   Server.exe heist und das Thema  Talk heisst steht hier  Server|Talk )
' - LinkTimeout (Zeit im ms in der der Server eine Antwort dem Client
'   senden muss)
'
' Die Verbindung findet durch das zuweisen der LinkMode eigenschaft des
' Client-Controls statt. Die LinkMode-Eigenschaft kann 0-keine,
' 1-automatisch, 2-manuell, 3-benachrichtigung enthalten.
' Bei 0 findet keine DDE-Verbindung statt, bei 1 wird eine Automatische
' DDE-Verbindung aufgebaut (heisst die Serverdaten werden automatisch an
' den Client gesendet), bei 2 muss der Client mithilfe von
' control.LinkRequest die Daten vom Server abhollen  !!!
'
' Vor dem zuweisen der LinkTopic-Eigenschaft des Clientcontrols MUSS !!!
' der Server bereits gestartet sein !!!!!
'
' Auf der Clientseite sind folgende Events verfgbar:
' - LinkOpen (wenn eine Verbindung geffnet wird)
' - LinkClose (wenn eine Verbindung geschlossen wurde)
' - LinkError (wenn ein Verbindungsfehler aufgetreten ist)
'
' Ein Makro kann der Client mit controlname.LinkExecute "makro..." an den
' Server senden.
Option Explicit

Public Ende As Boolean

Private Sub Command1_Click()    ' Makro ServerInfo

    If Label1.LinkMode = 0 Then ' Prffen ob Verbindung besteht
    
        ' Wenn nicht fehlermeldung
        MsgBox "Es existiert keine Verbindung" & vbNewLine & "mehr zum " & _
            "Server ! Makro fehlgeschlagen", vbCritical, "Problemm !"
            
        Exit Sub ' und raus
        
    End If
    
    Label1.LinkExecute "ServerInfo" ' sonst Makro senden
    
    ' Command1.SetFocus
End Sub

Private Sub Command2_Click() ' Makro Problemm

    If Label1.LinkMode = 0 Then
    
        MsgBox "Es existiert keine Verbindung" & vbNewLine & "mehr zum " & _
            "Server ! Makro fehlgeschlagen", vbCritical, "Problemm !"
            
        Exit Sub
        
    End If
    
    Label1.LinkExecute "Problem"
    
    ' Command2.SetFocus
End Sub

Private Sub Command3_Click() ' Makro DelText

    If Label1.LinkMode = 0 Then
    
        MsgBox "Es existiert keine Verbindung" & vbNewLine & "mehr zum " & _
            "Server ! Makro fehlgeschlagen", vbCritical, "Problemm !"
            
        Exit Sub
        
    End If
    
    Label1.LinkExecute "DelText"
    
    ' Command3.SetFocus
End Sub

Private Sub Command4_Click() ' Makro SetText

    If Label1.LinkMode = 0 Then
    
        MsgBox "Es existiert keine Verbindung" & vbNewLine & "mehr zum " & _
            "Server ! Makro fehlgeschlagen", vbCritical, "Problemm !"
            
        Exit Sub
        
    End If
    
    Label1.LinkExecute "SetText"
    
    ' Command4.SetFocus
End Sub

Private Sub Command5_Click() ' Marko HideServer

    If Label1.LinkMode = 0 Then
    
        MsgBox "Es existiert keine Verbindung" & vbNewLine & "mehr zum " & _
            "Server ! Makro fehlgeschlagen", vbCritical, "Problemm !"
            
        Exit Sub
        
    End If
    
    Label1.LinkExecute "HideServer"
    
    ' Command5.SetFocus
End Sub

Private Sub Command6_Click() ' Makro ShowServer

    If Label1.LinkMode = 0 Then
    
        MsgBox "Es existiert keine Verbindung" & vbNewLine & "mehr zum " & _
            "Server ! Makro fehlgeschlagen", vbCritical, "Problemm !"
            
        Exit Sub
        
    End If
    
    Label1.LinkExecute "ShowServer"
    
    ' Command6.SetFocus
End Sub

Private Sub Command7_Click()    ' Server Starten / Makro EndServer

    Dim i
    
    If Command7.Tag = 0 Then    ' Tageigenschaft prffen
    
        On Error Resume Next
        Text1.LinkMode = 1      ' Verbindung herstellen
        Label1.LinkMode = 1     ' Verbindung herstellen
        
        If Err <> 0 Then        ' Fals Fehler (Server nicht gestartet)
        
            i = Shell("Server.exe", vbNormalFocus)  ' Server starten
            Text1.LinkMode = 1  ' Verbindung herstellen
            Label1.LinkMode = 1 ' Verbindung herstellen
            
        End If
        
        Command7.Caption = "Makro: EndServer"
        Command7.Tag = 1
        
    Else
    
        If Label1.LinkMode = 0 Then
        
            MsgBox "Es existiert keine Verbindung" & vbNewLine & "mehr " & _
                "zum Server ! Makro fehlgeschlagen", vbCritical, _
                "Problemm !"
                
            Exit Sub
            
        End If
        
        Label1.LinkExecute "EndServer"
        Command7.Tag = 0
        Command7.Caption = "Start Server"
        
        ' Command7.SetFocus
    End If
    
End Sub

Private Sub Form_Load()

    Dim i
    
    On Error Resume Next
    Text1.LinkMode = 1  ' Verbindung herstellen
    Label1.LinkMode = 1 ' Verbindung herstellen
    
    If Err <> 0 Then    ' Fals Fehler (Server nicht gestartet)
    
        i = Shell("Server.exe", vbNormalFocus)  ' Server starten
        Text1.LinkMode = 1  ' Verbindung herstellen
        Label1.LinkMode = 1 ' Verbindung herstellen
        
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    Ende = True         ' Wegen LinkClose
    Text1.LinkMode = 0  ' Verbindung abbrechen
    Label1.LinkMode = 0 ' Verbindung abbrechen
    
End Sub

Private Sub Label1_LinkClose()  ' Verbindung geschlossen

    If Ende = False Then        ' Fals nicht Programmende
    
        MsgBox "Server nicht mehr verfgbar !", vbInformation, "Information"
        
        Command7.Tag = 0
        Command7.Caption = "Start Server"
        
    End If
    
End Sub

Private Sub Label1_LinkError(LinkErr As Integer) ' Verbindungsfehler

    MsgBox "LinkError"
    
End Sub

Private Sub Label1_LinkOpen(Cancel As Integer) ' Verbindung gestartet

    MsgBox "LinkOpen"
    
End Sub

